-- StubblePlough
-- Spec for StubblePlough to be used with chopped straw
-- by yumi

SpecializationUtil.registerSpecialization('StubblePlough', 'StubblePlough', g_currentModDirectory .. 'StubblePlough.lua');
local StubblePloughSpec = SpecializationUtil.getSpecialization('StubblePlough');

StubblePlough_Register = {};
local modItem = ModsUtil.findModItemByModName(g_currentModName);
StubblePlough_Register.version = (modItem and modItem.version) and modItem.version or "1.2";

--
StubblePlough_Register.initialized = false

function StubblePlough_Register:loadMap(name)
	if self.specAdded then return; end;

	print('*** StubblePlough v'..StubblePlough_Register.version..' specialization loading ***');

	local addedTo = {};

	for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
		if v ~= nil then
			-- has Plough spec -> continue
			local allowInsertion = SpecializationUtil.hasSpecialization(Plough, v.specializations);

			--local customEnvironment;
			if allowInsertion then
				 print(('\tvehicleType %q has plough spec'):format(v.name));
				if v.name:find('.') then
					customEnvironment = Utils.splitString('.', v.name)[1];
          --print(('\t\tcustomEnvironment=%q'):format(customEnvironment));
				end;

				if customEnvironment then
					-- has StubblePlough spec -> abort
					if rawget(SpecializationUtil.specializations, customEnvironment .. '.StubblePlough') ~= nil or rawget(SpecializationUtil.specializations, customEnvironment .. '.StubblePlough') ~= nil then
						 print(('\t\talready has spec "StubblePlough" -> allowInsertion = false'));
						allowInsertion = false;
					end;
				end;
			end;

			if allowInsertion then
				print(('\tStubblePlough spec added to %q'):format(v.name));
				table.insert(v.specializations, StubblePloughSpec);
				addedTo[#addedTo + 1] = v.name;
			end;
		end;
	end;


	self.specAdded = true;
end;

function StubblePlough_Register:update(dt)
  if not StubblePlough_Register.initialized then
    StubblePlough_Register.initialized = true -- Only initialize ONCE.
  end;
end;
  
-- Texts
StubblePlough.l10nTexts = {};
StubblePlough.l10nTexts["StubblePlough_Activate"] = g_i18n:getText("StubblePlough_Activate");
StubblePlough.l10nTexts["StubblePlough_Deactivate"] = g_i18n:getText("StubblePlough_Deactivate");

function StubblePlough_Register:deleteMap() end;
function StubblePlough_Register:keyEvent(unicode, sym, modifier, isDown) end;
function StubblePlough_Register:mouseEvent(posX, posY, isDown, isUp, button) end;
function StubblePlough_Register:draw() end;

addModEventListener(StubblePlough_Register);
